# -*- encoding: utf-8 -*-
# stub: unionf 0.1.0 ruby lib

Gem::Specification.new do |s|
  s.name = "unionf".freeze
  s.version = "0.1.0"

  s.required_rubygems_version = Gem::Requirement.new(">= 0".freeze) if s.respond_to? :required_rubygems_version=
  s.metadata = { "allowed_push_host" => "https://rubygems.org/" } if s.respond_to? :metadata=
  s.require_paths = ["lib".freeze]
  s.authors = ["Marlon Henry Schweigert".freeze, "Matheus Valenza".freeze]
  s.bindir = "exe".freeze
  s.date = "2017-09-30"
  s.description = "\n    In computer science, a disjoint-set data structure, also called a union\u2013find data structure or merge\u2013find set, is a data structure that keeps track of a set of elements partitioned into a number of disjoint (non-overlapping) subsets. It provides near-constant-time operations (bounded by the inverse Ackermann function) to add new sets, to merge existing sets, and to determine whether elements are in the same set. In addition to many other uses (see the Applications section), disjoint-sets play a key role in Kruskal's algorithm for finding the minimum spanning tree of a graph.\n\n    A disjoint-set forest consists of a number of elements each of which stores an id, a parent pointer, and, in efficient algorithms, a value called the \"rank\".\n\n    The parent pointers of elements are arranged to form one or more trees, each representing a set. If an element's parent pointer points to no other element, then the element is the root of a tree and is the representative member of its set. A set may consist of only a single element. However, if the element has a parent, the element is part of whatever set is identified by following the chain of parents upwards until a representative element (one without a parent) is reached at the root of the tree.\n\n    Forests can be represented compactly in memory as arrays in which parents are indicated by their array index.\n\n    Disjoint-set data structures model the partitioning of a set, for example to keep track of the connected components of an undirected graph. This model can then be used to determine whether two vertices belong to the same component, or whether adding an edge between them would result in a cycle. The Union\u2013Find algorithm is used in high-performance implementations of unification.\n\n    This data structure is used by the Boost Graph Library to implement its Incremental Connected Components functionality. It is also a key component in implementing Kruskal's algorithm to find the minimum spanning tree of a graph.\n\n    Note that the implementation as disjoint-set forests doesn't allow the deletion of edges, even without path compression or the rank heuristic.\n\n    Sharir and Agarwal report connections between the worst-case behavior of disjoint-sets and the length of Davenport\u2013Schinzel sequences, a combinatorial structure from computational geometry.\n  ".freeze
  s.email = ["fleyhe0@gmail.com".freeze]
  s.homepage = "http://www.github.com/Schweigert/unionf".freeze
  s.licenses = ["MIT".freeze]
  s.rubygems_version = "3.2.22".freeze
  s.summary = "Union-find algorithm.".freeze

  s.installed_by_version = "3.2.22" if s.respond_to? :installed_by_version

  if s.respond_to? :specification_version then
    s.specification_version = 4
  end

  if s.respond_to? :add_runtime_dependency then
    s.add_development_dependency(%q<bundler>.freeze, ["~> 1.15"])
    s.add_development_dependency(%q<rake>.freeze, ["~> 10.0"])
  else
    s.add_dependency(%q<bundler>.freeze, ["~> 1.15"])
    s.add_dependency(%q<rake>.freeze, ["~> 10.0"])
  end
end
